
#include <stdio.h> 
#include <string.h>
#include "abc.h" 


abc_filter_t abcfilter(parms)
struct filter_params  parms;
{
int i;

abc_filter_t the_filter;
the_filter = (abc_filter_t) malloc( (unsigned) sizeof(struct abc_filter));

the_filter->f_params = parms;   /*this doesn't copy, I guess...  so caller controls these vital*/
strcpy(the_filter->name, parms.name);
the_filter->activity = initializing;
the_filter->alpha = parms.alpha;
the_filter->beta = parms.beta;
the_filter->gamma = parms.gamma;
the_filter->age_ticks = 0;
the_filter->age_secs = 0.0;
the_filter->data_ticks = 0;
the_filter->data_secs = 0.0;
the_filter->nodata_ticks = 0;
the_filter->nodata_secs = 0.0;
the_filter->innov = 0.0;
the_filter->timeout_ticks = irint(parms.timeout_secs/parms.time_step);
the_filter->timeout_secs = parms.timeout_secs;
the_filter->xcurr = the_filter->vcurr = the_filter->acurr =
the_filter-> xave = the_filter->vave =  the_filter->aave= 0.0;
the_filter->x_pred = the_filter->v_pred = the_filter->a_pred =
the_filter-> x_future = the_filter->v_future =  the_filter->a_future= 0.0;
the_filter-> xlast = the_filter->vlast =  the_filter->alast= 0.0;
the_filter-> x_est = the_filter->v_est =  the_filter->a_est= 0.0;
return the_filter;
}

abc_reset(the_filter)
abc_filter_t the_filter;
{
the_filter->activity = initializing;
the_filter->age_ticks = 0;
the_filter->age_secs = 0.0;
the_filter->data_ticks = 0;
the_filter->data_secs = 0.0;
the_filter->nodata_ticks = 0;
the_filter->nodata_secs = 0.0;
the_filter->innov = 0.0;
the_filter->xcurr = the_filter->vcurr = the_filter->acurr =
the_filter-> xave = the_filter->vave =  the_filter->aave= 0.0;
the_filter->x_pred = the_filter->v_pred = the_filter->a_pred =
the_filter-> x_future = the_filter->v_future =  the_filter->a_future= 0.0;
the_filter-> xlast = the_filter->vlast =  the_filter->alast= 0.0;
the_filter-> x_est = the_filter->v_est =  the_filter->a_est= 0.0;

}


abc_dump(abc)
abc_filter_t abc;
{
printf("\n ABC filter dump.....");
printf("\n Name: %s",abc->name);
printf("\n Activity: %d", abc->activity);
printf("\n A,B,C: %f %f %f", abc->alpha, abc->beta, abc->gamma);
printf("\n Age in ticks and secs: %d %f",abc->age_ticks, abc->age_secs);
printf("\n Data since (ticks, secs): %d %f", abc->data_ticks, abc->data_secs);
printf("\n No data since (ticks, secs): %d %f", abc->nodata_ticks,
       abc->nodata_secs);
printf("\n Timeout limit (ticks, secs): %d %f", abc->timeout_ticks,
       abc->timeout_secs);

printf("\n xlast, vlast, alast: %f %f %f", abc->xlast, abc->vlast, abc->alast);

printf("\n xave, vave, aave: %f %f %f", abc->xave, abc->vave, abc->aave);
printf("\n xcurr, vcurr, acurr: %f %f %f", abc->xcurr, abc->vcurr, abc->acurr);
printf("\n xpred, vpred, apred: %f %f %f",
       abc->x_pred, abc->v_pred, abc->a_pred);
printf("\n Innovation: %f", abc->innov);
printf("\n xest, vest, aest: %f %f %f", abc->x_est, abc->v_est, abc->a_est);
printf("\n xfut, vfut, afut: %f %f %f",
       abc->x_future, abc->v_future, abc->a_future);
printf("\n\n");
}



/*here is the version of run that takes the current timestamp and does
the same number as the above -- a variable timestep ABC. hope it works...*/

/* here a "tick" is just number of times the sucker has been called...nothing
        to do with time */


void run(abc,sgnal, X, advance, time_stamp)
abc_filter_t abc;
data_type sgnal; 
double X, advance, time_stamp;
{

double this_step;  /*trulylocal?*/

double adv;
double N;

adv =  advance;
this_step = time_stamp - abc->age_secs;
abc->activity = (abc->age_ticks < abc->f_params.init_ticks)
?  initializing : tracking;
	/*tracking or predicting actually but we'll find that out later*/
		


if ( abc->activity == initializing)
	{

	if (sgnal == nodata) {abc->activity= timed_out; return;} 
		/*policy decision -- don't initialize through dropout */

	N = (double)(abc->age_ticks) + 1.0;
	        /*for running average in itialization*/
	/* this use of N means we trust the info from the initial */
        /* ticks equally (regardless of their separation in time, say*/

/* there follows a segment to initialize the filter..keeps a runnning ave.
of the velocity, uses latest x value.   This idea is appropriate for const
velocity but may not be for any other velocity */

	 if (abc->age_ticks >= 0)
		 { abc->xlast = abc->xcurr;
		abc->xcurr = X;
		}

	 if (abc->age_ticks >= 1)
		 {
		 abc->vlast = abc->vcurr;
		  abc->vcurr = (abc->xcurr - abc->xlast)/this_step;
		 /* vave = vave + (vcurr - vave)/(N-1.0);  useless, right?*/
		 }
	if (abc->age_ticks >= 2)
                        {
                        abc->alast = abc->acurr;
                        abc->acurr = (abc->vcurr - abc->vlast)/this_step;
                        abc->aave = abc->aave +
			    (abc->acurr - abc->aave)/(N-2.0);
                        }


	if ( abc->age_ticks < 2)  abc->activity = invalid; 

/* now compute the estimates during initialization */

		  abc->x_est =  abc->xcurr;
/*		 v_est = vcurr - 0.5 * aave*this_step; */
		  abc->v_est =  abc->vcurr;
		 abc->a_est =  abc->aave;
		  abc->x_future =  abc->x_est +  abc->v_est*(adv)
		      + 0.5 *  abc->a_est * (adv*adv);
		  abc->v_future =  abc->v_est +  adv*abc->a_est; 
		 abc->a_future =  abc->a_est;

		}	
	else  /*filtering*/
	{

/* start timer if no data...*/

	if (sgnal == nodata)
		{
		if ((abc->nodata_secs += this_step) >=  abc->timeout_secs) 
			{abc->activity= timed_out; return;}
		 abc->activity = predicting;
		 abc->nodata_ticks++;
		 abc->data_ticks = 0;
		 abc->data_secs = 0.0;

		 abc->x_est =  abc->x_est +  abc->v_est*this_step
		     + 0.5* abc->a_est*this_step*this_step;
		 /*predict based on last known vel, acc..*/
		 abc->v_est =  abc->v_est +  abc->a_est*this_step ;
		      /*last known acc...*/
		}

/* do you believe it  the alpha-beta equations! */

	if (sgnal == data)
		{
		abc->activity =  tracking;
		abc->nodata_ticks = 0;
		abc->nodata_secs = 0.0;
		 abc->data_ticks++;
		 abc->data_secs+= this_step;
		 abc->x_pred =  abc->x_est + this_step* abc->v_est
		     +0.5* abc->a_est*this_step*this_step;
/*printf("\n xpred, xest, vest aest, this_step: %f %f %f %f %f",
       abc->x_pred, abc->x_est, abc->v_est, abc->a_est, this_step);
*/
		 abc->v_pred =  abc->v_est + this_step* abc->a_est;

		 abc->innov = X -  abc->x_pred;
/*
printf("\n innov, X,  xpred:   %f %f %f",
	abc->innov, X, abc->x_pred);
*/
		abc->x_est = abc->x_pred + abc->f_params.alpha*abc->innov;
/*
printf("\n xest, xpred, alpha, innov :  %f %f %f %f",
       abc->x_est, abc->x_pred, abc->f_params.alpha, abc->innov);
*/
		abc->v_est = 
		    abc->v_pred + (abc->f_params.beta/this_step)*abc->innov;
		abc->a_est =
		    abc->a_est + (abc->f_params.gamma/
				  (this_step*this_step))*abc->innov;

		}

 		abc->x_future = abc->x_est + abc->v_est*adv
		    + 0.5*abc->a_est*adv*adv;
               abc->v_future = abc->v_est + adv*abc->a_est;
		abc->a_future = abc->a_est;

	}

abc->age_ticks++;  /*go to next time step*/
abc->age_secs = time_stamp; 

}  









