/* to be used with AB.cc and NAB.cc */


#ifndef _NAB_h
#define _NAB_h
#include <stream.h>
#include "Ran.h"
#include "filt.h"

/* streamlined alpha-beta filter.  User must supply his own a-b.  I have formulae
for them, probably should supply the ancillary routines to help out */

/* This  header works for the  Noisy AB filter, with slots in the f_parms for noise value
that is to be added to the PREDICTION INTERVAL.  So if it thinks it's predicting
at one advance, really it goes to another advance via addition of noise.  */

/* it also work for the simple AB filter  */



/* note that if we supplied lambda, then alpha and beta are determined, and
we would hjave a reasonable # of parameters, wouldn't ahve to worry with this struct */

/* the idea of the struct is to simplify the calls, which otherwise
	get cluttered up with lots of parameters.  On the other hand this means
	the user has to do a lot more work...maybe need another layer to protect him.
	Another aspect is that the user has to allocate these records and pass them
	into filter, but they really belong to the filter, who can delete them.  Not
	so nice --- they really should physically  live in the filter...what to do?? */

class filter{

protected:

	filter_params f_params;
	int timeout_ticks;
	double xlast, xcurr, vlast, vcurr, vave;  //for the a-b filter calc.
	double x_pred, v_pred,  innov; 
	double N;

public:
	filter_activity activity;
	double x_est, v_est;    //estimated variable
	double x_future, v_future; //predicted variable at time advance in the future;
					//noisy of course ...heh heh
	int age_ticks;		// total age;
	double age_secs;		
	int data_ticks; //how long we've seen target
	double data_secs;
	int nodata_ticks; // how long we've not seen target
	double nodata_secs;

	// idea was to make all the above public so user could just inquire...

	filter(filter_params parms);  //create and init
	void run(data_type signal, double x, double advance); //assumes runs every tick. 
	void run(data_type signal, double x, double advance, double timestamp);
		//assumes runs at random times... 
	void dump(void);
};


#endif
